Attribute VB_Name = "Capture"
Option Explicit



Public Sub ReadingsGet()
    DebugLog "Analysing received data"
    PositionCur ""
    PositionCur LocationTag
    With Current
        .Tim = FindString("<TD align=middle noWrap>", "</TD>")
        .Tmp = FindSingle("<TD align=middle>", "</TD>")
        PositionCur "</TD>"     ' skip dewpoint
        .Hum = FindSingle("<TD align=middle>", "</TD>")
        .Dir = FindString("<TD align=middle>", "</TD>")
        .Wind = FindSingle("<TD align=middle>", "</TD>")
        PositionCur "</TD>"     ' skip speed in knots
        .Gust = FindSingle("<TD align=middle>", "</TD>")
        PositionCur "</TD>"     ' skip speed in knots
        .Prs = FindSingle("<TD align=middle>", "</TD>")
        .Rain = FindSingle("<TD align=middle>", "</TD>")
        
        If .Tmp <> Display.Tmp Then Previous.Tmp = Display.Tmp
        If .Hum <> Display.Hum Then Previous.Hum = Display.Hum
        If .Dir <> Display.Dir Then Previous.Dir = Display.Dir
        If .Wind <> Display.Wind Then Previous.Wind = Display.Wind
        If .Gust <> Display.Gust Then Previous.Gust = Display.Gust
        If .Prs <> Display.Prs Then Previous.Prs = Display.Prs
        If .Rain <> Display.Rain Then Previous.Rain = Display.Rain
        
        DebugLog "Time = " & .Tim
        DebugLog "Tmp = " & Format$(.Tmp)
        DebugLog "Hum = " & Format$(.Hum)
        DebugLog "Dir = " & .Dir
        DebugLog "Wind = " & Format$(.Wind)
        DebugLog "Gust = " & Format$(.Gust)
        DebugLog "Prs = " & Format$(.Prs)
        DebugLog "Rain = " & Format$(.Rain)
        
    End With
    
    ValidData = True
    Log Current
    
End Sub


Public Sub DisplayReadings()
    Dim i As Integer

    Display = Current
    
    With Display
        Main.Tmp = DisplayString(.Tmp, "")
        Main.TmpUnits = Chr$(186) & "C"
        Main.Hum = DisplayString(.Hum, "%")
        
        ' first set the compass to blank to show if we have an error
        ' then search through array of ipcs looking for a tag that matches
        ' the wind direction.  Copy pic when found.
        Main.WindDir = Main.BlankPic
        For i = 0 To 16
            If .Dir = Main.WindDirPic(i).Tag Then Main.WindDir = Main.WindDirPic(i)
        Next i
        Main.WindDir.Circle (45, 45), 65
        
        If .Wind = DataError Then
            Main.Wind = "-"
        Else
            If .Wind = .Gust Or .Gust = DataError Then
                Main.Wind = Format$(.Wind)
            Else
                Main.Wind = Format$(.Wind) & " to " & Format$(.Gust)
            End If
        End If
        
        Main.Prs = DisplayString(.Prs, "")
        Main.Rain = DisplayString(.Rain, " mm")
    End With
End Sub

Private Function DisplayString(Data As Single, Units As String) As String
    If Data = DataError Then
        DisplayString = "-"
    Else
        DisplayString = Format$(Data) & Units
    End If
End Function
