Attribute VB_Name = "OpenSoundModule"
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Open the sound channel and leave it open
' this is to fix a bug in the SoundMax drivers for the Asus A8R-MVB motherboard
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit
Private Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long

' DirectSound access
Dim DX As DirectX8
Dim DS As DirectSound8
Dim dsToneBuffer As DirectSoundSecondaryBuffer8
Dim desc As DSBUFFERDESC
'
' Global variables
Const SRATE = 44100                 ' Sampling Rate
Const DUR = 0.1                     ' Sound duration
Dim sbuf(0 To DUR * SRATE) As Integer

Public Sub OpenSound()
    Dim S1 As String

    ' only run this on the machine called Multimedia
    S1 = Space(512)
    GetComputerName S1, Len(S1)
    If InStr(1, Trim$(S1), "Multimedia", 1) <> 1 Then Exit Sub
    
    ' initialise DirectSound
    Set DX = New DirectX8
    Set DS = DX.DirectSoundCreate("")
    DS.SetCooperativeLevel Main.hwnd, DSSCL_NORMAL
    '
    ' create a buffer
    desc.fxFormat.nFormatTag = WAVE_FORMAT_PCM
    desc.fxFormat.nSize = 0
    desc.fxFormat.lExtra = 0
    desc.fxFormat.nChannels = 1
    desc.fxFormat.lSamplesPerSec = SRATE
    desc.fxFormat.nBitsPerSample = 16
    desc.fxFormat.nBlockAlign = 2
    desc.fxFormat.lAvgBytesPerSec = 2 * SRATE
    desc.lFlags = 0
    desc.lBufferBytes = 2 * DUR * SRATE
    Set dsToneBuffer = DS.CreateSoundBuffer(desc)
    '
    ' play the buffer
    dsToneBuffer.Play DSBPLAY_DEFAULT
    '
    ' freeze the play leaving the sound channel open
    dsToneBuffer.Stop
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' this is the original code for creating a sound
' just in case I might need it for reference
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' DirectSound access
'Dim DX As DirectX8
'Dim DS As DirectSound8
'Dim dsToneBuffer As DirectSoundSecondaryBuffer8
'Dim desc As DSBUFFERDESC
'
' Global variables
'Const PI = 3.14159265358979
'Const SRATE = 44100             ' Sampling Rate
'Const DUR = 1                   ' Tone duration
'Const FREQ = 500                ' Tone frequency
'Dim sbuf(0 To DUR * SRATE) As Integer

' Open the sound channel and leave it open
' this is to fix a bug in the soundMax drivers for the Asus A8R-MVB motherboard
'Public Sub OpenSound()
'
'    ' initialise DirectSound
'    Set DX = New DirectX8
'    Set DS = DX.DirectSoundCreate("")
'    DS.SetCooperativeLevel Main.hwnd, DSSCL_NORMAL
'    '
'    ' create a buffer
'    desc.fxFormat.nFormatTag = WAVE_FORMAT_PCM
'    desc.fxFormat.nSize = 0
'    desc.fxFormat.lExtra = 0
'    desc.fxFormat.nChannels = 1
'    desc.fxFormat.lSamplesPerSec = SRATE
'    desc.fxFormat.nBitsPerSample = 16
'    desc.fxFormat.nBlockAlign = 2
'    desc.fxFormat.lAvgBytesPerSec = 2 * SRATE
'    desc.lFlags = 0
'    desc.lBufferBytes = 2 * DUR * SRATE
'    Set dsToneBuffer = DS.CreateSoundBuffer(desc)
'    '
'    ' create a tone
'    Dim i
'    For i = 0 To DUR * SRATE
'        sbuf(i) = 10000 * Sin(2 * PI * FREQ * i / SRATE)
'    Next i
'    '
'    ' copy tone to buffer
'    dsToneBuffer.WriteBuffer 0, 2 * DUR * SRATE, sbuf(0), DSBLOCK_DEFAULT
'
'    ' play the tone
'    dsToneBuffer.Play DSBPLAY_DEFAULT
'    '
'    dsToneBuffer.Stop
'End Sub

