Attribute VB_Name = "PROFILE"

' Subroutine to read from the registry or a private .ini file
' Max string that this will return is 256 chars
'
Function ProfileRead(Key As String, Deflt As String) As String
    ProfileRead = GetSetting(App.EXEName, App.Title, Key, Deflt)

End Function


' Subroutine to read a long integer from the registry
' It will return the default if the key does not exist or the value returned is greater than MaxValue
' or less than MinValue.  This is used for sanity checking on the returned value.
'
Function ProfileReadLong(Key As String, Deflt As Long, MinValue As Long, MaxValue As Long) As Long
    Dim i As Long
    i = val(GetSetting(App.EXEName, App.Title, Key, Format$(Deflt)))
    If i > MaxValue Or i < MinValue Then i = Deflt
    ProfileReadLong = i
End Function

' Subroutine to write to the registry or a private .ini file with error checking
' If the second argument is the string "NULL" then the key is deleted from the .ini file
'
Sub ProfileWrite(Key As String, Value As String)
    If Value = "NULL" Then
        DeleteSetting App.EXEName, App.Title, Key
    Else
        SaveSetting App.EXEName, App.Title, Key, Value
    End If
End Sub

