Attribute VB_Name = "VariablesModule"
Option Explicit

' this module holds all operations dealing with variables extracted from the HTML text
' all variables are stored and returned as strings
' only four operations can be done with variables
'  = GetVar("SCRIPT-NAME")      returns the value
'  SetVar "SCRIPT-NAME", Value   sets the value
'  call the DisplayReadings subroutine to display all variables
'  call the WriteLogFile subroutine to write the current observations to a log file

Dim Tim As String
Dim Tmp As String
Dim Hum As String
Dim Direction As String
Dim Wind As String
Dim Gust As String
Dim Prs As String
Dim Rain As String
Dim CMin As String
Dim CMinTime As String
Dim CMax As String
Dim CMaxTime As String
Dim FTim As String
Dim FTmps As String
Dim FSummary As String
Dim FDay As String
Dim T1Day As String
Dim T1Headline As String
Dim T1MaxMin As String
Dim T2Day As String
Dim T2Headline As String
Dim T2MaxMin As String
Dim T3Day As String
Dim T3Headline As String
Dim T3MaxMin As String
Dim T4Day As String
Dim T4Headline As String
Dim T4MaxMin As String
Dim T5Day As String
Dim T5Headline As String
Dim T5MaxMin As String
Dim T6Day As String
Dim T6Headline As String
Dim T6MaxMin As String
Dim SatImg As String
Dim SatTime As String
Dim SatTZ As String
Dim URLSat As String
Dim URLASat As String
Dim URLRain As String
Dim URLARain As String
Dim SynImg As String
Dim URLSyn As String
Dim URLSyn36 As String
Dim URLFullForecast As String


Public Function GetVar(Name As String) As String
    Select Case UCase$(Name)
        Case "C-TIME"
            GetVar = Tim
        Case "C-TEMP"
            GetVar = Tmp
        Case "C-HUMID"
            GetVar = Hum
        Case "C-WIND-DIR"
            GetVar = Direction
        Case "C-WIND-SPEED"
            GetVar = Wind
        Case "C-WIND-GUST"
            GetVar = Gust
        Case "C-BAROMETER"
            GetVar = Prs
        Case "C-RAINFALL"
            GetVar = Rain
        Case "C-MIN"
            GetVar = CMin
        Case "C-MINTIME"
            GetVar = CMinTime
        Case "C-MAX"
            GetVar = CMax
        Case "C-MAXTIME"
            GetVar = CMaxTime
        Case "F-TIME"
            GetVar = FTim
        Case "F-MAXMIN"
            GetVar = FTmps
        Case "F-HEADLINE"
            GetVar = FSummary
        Case "F-DAY"
            GetVar = FDay
        Case "T-1DAY"
            GetVar = T1Day
        Case "T-1HEADLINE"
            GetVar = T1Headline
        Case "T-1MAXMIN"
            GetVar = T1MaxMin
        Case "T-2DAY"
            GetVar = T2Day
        Case "T-2HEADLINE"
            GetVar = T2Headline
        Case "T-2MAXMIN"
            GetVar = T2MaxMin
        Case "T-3DAY"
            GetVar = T3Day
        Case "T-3HEADLINE"
            GetVar = T3Headline
        Case "T-3MAXMIN"
            GetVar = T3MaxMin
        Case "T-4DAY"
            GetVar = T4Day
        Case "T-4HEADLINE"
            GetVar = T4Headline
        Case "T-4MAXMIN"
            GetVar = T4MaxMin
        Case "T-5DAY"
            GetVar = T5Day
        Case "T-5HEADLINE"
            GetVar = T5Headline
        Case "T-5MAXMIN"
            GetVar = T5MaxMin
        Case "T-6DAY"
            GetVar = T6Day
        Case "T-6HEADLINE"
            GetVar = T6Headline
        Case "T-6MAXMIN"
            GetVar = T6MaxMin
        Case "SAT-IMG"
            GetVar = SatImg
        Case "SAT-TIME"
            GetVar = SatTime
        Case "SAT-TZ"
            GetVar = SatTZ
        Case "URL-SAT"
            GetVar = URLSat
        Case "URL-ASAT"
            GetVar = URLASat
        Case "URL-RAIN"
            GetVar = URLRain
        Case "URL-ARAIN"
            GetVar = URLARain
        Case "SYN-IMG"
            GetVar = SynImg
        Case "URL-SYN"
            GetVar = URLSyn
        Case "URL-SYN-36"
            GetVar = URLSyn36
        Case "URL-FULL-FORECAST"
            GetVar = URLFullForecast
        Case Else
            Err.Raise cInvalidVar, , "Invalid variable: " & Name
    End Select
End Function

Public Sub SetVar(Name As String, Variable As String)
    Select Case UCase$(Name)
        Case "C-TIME"
            Tim = Variable
        Case "C-TEMP"
            Tmp = Variable
        Case "C-HUMID"
            Hum = Variable
        Case "C-WIND-DIR"
            Direction = Variable
        Case "C-WIND-SPEED"
            Wind = Variable
        Case "C-WIND-GUST"
            Gust = Variable
        Case "C-BAROMETER"
            Prs = Variable
        Case "C-RAINFALL"
            Rain = Variable
        Case "C-MIN"
            CMin = Variable
        Case "C-MINTIME"
            CMinTime = Variable
        Case "C-MAX"
            CMax = Variable
        Case "C-MAXTIME"
            CMaxTime = Variable
        Case "F-TIME"
            FTim = Variable
        Case "F-MAXMIN"
            FTmps = Variable
        Case "F-HEADLINE"
            FSummary = Variable
        Case "F-DAY"
            FDay = Variable
        Case "T-1DAY"
            T1Day = Variable
        Case "T-1HEADLINE"
            T1Headline = Variable
        Case "T-1MAXMIN"
            T1MaxMin = Variable
        Case "T-2DAY"
            T2Day = Variable
        Case "T-2HEADLINE"
            T2Headline = Variable
        Case "T-2MAXMIN"
            T2MaxMin = Variable
        Case "T-3DAY"
            T3Day = Variable
        Case "T-3HEADLINE"
            T3Headline = Variable
        Case "T-3MAXMIN"
            T3MaxMin = Variable
        Case "T-4DAY"
            T4Day = Variable
        Case "T-4HEADLINE"
            T4Headline = Variable
        Case "T-4MAXMIN"
            T4MaxMin = Variable
        Case "T-5DAY"
            T5Day = Variable
        Case "T-5HEADLINE"
            T5Headline = Variable
        Case "T-5MAXMIN"
            T5MaxMin = Variable
        Case "T-6DAY"
            T6Day = Variable
        Case "T-6HEADLINE"
            T6Headline = Variable
        Case "T-6MAXMIN"
            T6MaxMin = Variable
        Case "SAT-IMG"
            SatImg = Variable
        Case "SAT-TIME"
            SatTime = Variable
        Case "SAT-TZ"
            SatTZ = Variable
        Case "URL-SAT"
            URLSat = Variable
        Case "URL-ASAT"
            URLASat = Variable
        Case "URL-RAIN"
            URLRain = Variable
        Case "URL-ARAIN"
            URLARain = Variable
        Case "SYN-IMG"
            SynImg = Variable
        Case "URL-SYN"
            URLSyn = Variable
        Case "URL-SYN-36"
            URLSyn36 = Variable
        Case "URL-FULL-FORECAST"
            URLFullForecast = Variable

        Case Else
            Err.Raise cInvalidVar, , "Invalid variable: " & Name
    End Select
End Sub


'Public Sub DisplaySatellite()
'    If Main.TabBar.TabVisible(SatelliteTab) Then
'        ExecuteQuery Main.WBSat, GetVar("SAT-IMG"), False
'        Main.WBSat.ToolTipText = " Image recorded at " & Format$(TimeValue(GetVar("SAT-TIME")) + TimeSerial(GetVar("SAT-TZ"), 0, 0), "h:mmam/pm ")
'        DisplayReadings
'    End If
'End Sub

'Public Sub DisplaySynoptic()
'    If Main.TabBar.TabVisible(SynopticTab) Then
'        ExecuteQuery Main.WBSynoptic, GetVar("SYN-IMG"), False
'        Main.WBSynoptic.ToolTipText = "Current Synoptic Chart"
'        DisplayReadings
'    End If
'End Sub



Public Sub DisplayReadings()
    Static LastSatImageURL As String
    Static LastSynImageURL As String
    Dim i As Integer
    Dim j As Integer
    Dim s As String
    
    GotError = False

    If InStr(GetVar("C-TEMP"), ".") = 0 Then
        Main.Tmp = GetVar("C-TEMP") & ".0"
    Else
        Main.Tmp = GetVar("C-TEMP")
    End If
    Main.TmpUnits = Chr$(186) & "C"
    Main.TmpUnits.Visible = (GetVar("C-TEMP") <> cInvalidValue)
    
    ' Tooltip for the System Tray icon
    Call Shell_NotifyIcon(NIM_ADD, IconData)  ' Add the form's icon in the tray incase it has been lost
    IconData.szTip = "Weather Station: " & Main.Tmp & "C" & Chr(0)
    Call Shell_NotifyIcon(NIM_MODIFY, IconData)  ' Update the form's icon in the tray
    
    Main.Hum = GetVar("C-HUMID")
    If Val(Main.Hum) > 0 Then Main.Hum = Main.Hum & "%"
    
    Main.Prs = GetVar("C-BAROMETER")
    
    For i = 0 To 3
        Main.CurrentLabel(i).Visible = True
    Next i

    
    If Val(GetVar("C-RAINFALL")) > 0 Then
        Main.Rain = GetVar("C-RAINFALL") & " mm"
    Else
        Main.Rain = "nil"
    End If
    
    If GetVar("C-WIND-DIR") = "CALM" Or (GetVar("C-WIND-SPEED") = "0" And GetVar("C-WIND-GUST") = "0") Then
        Main.WindDir = Images.WindDirPic(16)
        Main.Wind = "No Wind"
        Main.CurrentLabel(3).Visible = False
    Else
        ' first set the compass to blank to show if we have an error
        ' then search through array of ipcs looking for a tag that matches
        ' the wind direction.  Copy pic when found.
        Main.WindDir = Main.BlankPic
        For i = 0 To 16
            If GetVar("C-WIND-DIR") = Images.WindDirPic(i).Tag Then Main.WindDir = Images.WindDirPic(i)
        Next i
        Main.WindDir.Circle (36, 36), 55, Main.BackColor     ' make into a circular picture
        
        If GetVar("C-WIND-SPEED") = GetVar("C-WIND-GUST") Or GetVar("C-WIND-GUST") = "" Or GetVar("C-WIND-GUST") = "-" Then
            Main.Wind = GetVar("C-WIND-SPEED")
        Else
            Main.Wind = GetVar("C-WIND-SPEED") & " to " & GetVar("C-WIND-GUST")
        End If
    End If
    
    Main.Frame2.Visible = True
    
    If GetVar("C-MINTIME") = cInvalidValue Or GetVar("C-MINTIME") = "" Then
        Main.dLastMin = ""
        Main.dlLastMin.Visible = False
    Else
        Main.dLastMin = GetVar("C-MIN") & " at " & GetVar("C-MINTIME")
        Main.dlLastMin.Visible = True
    End If
    
    If GetVar("C-MAXTIME") = cInvalidValue Or GetVar("C-MAXTIME") = "" Then
        Main.dLastMax = ""
        Main.dlLastMax.Visible = False
    Else
        Main.dLastMax = GetVar("C-MAX") & " at " & GetVar("C-MAXTIME")
        Main.dlLastMax.Visible = True
    End If
      
    If GetVar("F-DAY") <> "" Then
        Main.Frame1.Visible = True
        If InStr(1, GetVar("F-DAY"), Format$(Now, "dddd"), vbTextCompare) > 0 Then
            Main.ForecastLabel = "Forecast for the remainder of today"
        ElseIf InStr(1, GetVar("F-DAY"), Format$(Now + 1, "dddd"), vbTextCompare) > 0 Then
            Main.ForecastLabel = "Forecast for tomorrow"
        Else
            Main.ForecastLabel = "Forecast"
        End If
    End If
    
    Main.ForecastLabel.Visible = True
    
    Main.CurrentForecast = GetVar("F-MAXMIN") & "     " & GetVar("F-HEADLINE")
    
    s = GetVar("C-TIME")
    If InStr(s, ":") = 0 Then s = Left$(s, 2) & ":" & Right$(s, 2) ' add a colon between hours and minutes
    On Error Resume Next
    s = Format$(TimeValue(s), "h:mm am/pm")
    If Err Then
        GotError = True
        Main.StatusBar = "Error - cannot download correct data"
    Else
        Main.StatusBar = "Readings current at " & s
    End If
    On Error GoTo 0
        
    s = GetVar("F-TIME")
    If InStr(s, ":") = 0 Then s = Left$(s, 2) & ":" & Right$(s, 2) ' add a colon between hours and minutes
    On Error Resume Next
    's = Format$(TimeValue(s), "h:mm am/pm")
    If Err Then
        GotError = True
    Else
        Main.FStatusBar = "Forecast issued at " & s
    End If
    On Error GoTo 0
    Main.ForecastLabel.ToolTipText = " " & Main.FStatusBar & " "
    Main.CurrentForecast.ToolTipText = " " & Main.FStatusBar & " "
        
    Main.dlFDay1 = GetVar("T-1DAY")
    Main.dmFDay1 = GetVar("T-1MAXMIN")
    Main.dFDay1 = GetVar("T-1HEADLINE")
    Main.dlFDay2 = GetVar("T-2DAY")
    Main.dmFDay2 = GetVar("T-2MAXMIN")
    Main.dFDay2 = GetVar("T-2HEADLINE")
    Main.dlFDay3 = GetVar("T-3DAY")
    Main.dmFDay3 = GetVar("T-3MAXMIN")
    Main.dFDay3 = GetVar("T-3HEADLINE")
    Main.dlFDay4 = GetVar("T-4DAY")
    Main.dmFDay4 = GetVar("T-4MAXMIN")
    Main.dFDay4 = GetVar("T-4HEADLINE")
    Main.dlFDay5 = GetVar("T-5DAY")
    Main.dmFDay5 = GetVar("T-5MAXMIN")
    Main.dFDay5 = GetVar("T-5HEADLINE")
    Main.dlFDay6 = GetVar("T-6DAY")
    Main.dmFDay6 = GetVar("T-6MAXMIN")
    Main.dFDay6 = GetVar("T-6HEADLINE")
    
    ' we use Main.BlankPic to calculate the string screen length because TextWidth will not work for a Label.
    ' for this reason we set Main.BlankPic to the same font as used in the Label.
    'Main.BlankPic.Font = Main.dTrend.Font
    'Main.BlankPic.FontBold = Main.dTrend.FontBold
    'Main.BlankPic.FontSize = Main.dTrend.FontSize
    'If Main.dTrend.Width < Main.BlankPic.TextWidth(GetVar("T-TREND")) Then
    '    Main.dTrend = "Trend:  " & GetVar("T-TREND")
    'Else
    '    Main.dTrend = "Trend:" & vbCrLf & GetVar("T-TREND")
    'End If
    
    'If Main.TabBar.TabVisible(SatelliteTab) And GetVar("SAT-TIME") <> "" And GetVar("SAT-TIME") <> cInvalidValue And GetVar("SAT-IMG") <> LastSatImageURL Then
    If Main.TabBar.TabVisible(SatelliteTab) And GetVar("SAT-IMG") <> "" Then
        'Unload Main.WBSat(0)
        'Load Main.WBSat(0)
        'Main.WBSat(0).Visible = True
        On Error GoTo ExecuteSatErr
        Main.WBSat(0).Navigate GetVar("SAT-IMG")
        On Error GoTo 0
        SetVar "SAT-IMG", ""                ' this prevents a reload of the image until the next schedule
        'LastSatImageURL = GetVar("SAT-IMG")
        On Error Resume Next
        Main.WBSat(0).ToolTipText = " Image recorded at " & Format$(TimeValue(GetVar("SAT-TIME")) + TimeSerial(GetVar("SAT-TZ"), 0, 0), "h:mmam/pm ")
        'Main.WBSat(0).Visible = True
        On Error GoTo 0
    End If
    
    If Main.TabBar.TabVisible(SynopticTab) And GetVar("SYN-IMG") <> "" Then
        'Unload Main.WBSynoptic(0)
        'Load Main.WBSynoptic(0)
        'Main.WBSynoptic(0).Visible = True
        On Error GoTo ExecuteSynErr
        Main.WBSynoptic(0).Navigate GetVar("SYN-IMG")
        On Error GoTo 0
        SetVar "SYN-IMG", ""                ' this prevents a reload of the image until the next schedule
        Main.WBSynoptic(0).ToolTipText = "Current Synoptic Chart"
    End If
    
    AddToGraph GetVar("C-TIME"), GetVar("C-TEMP"), GetVar("C-BAROMETER"), GetVar("C-RAINFALL"), GetVar("C-WIND-DIR"), GetVar("C-WIND-SPEED"), GetVar("C-HUMID")
    
    DoEvents
    
    WriteLogFile
    Exit Sub
    'BrowseObject.Navigate GetVar("SYN-IMG")
    
ExecuteSatErr:
    DebugLog "Execute error: " & GetVar("SAT-IMG") & " Error = " & Str(Err.Number) & " (" & Err.Description & ")"
    Exit Sub

ExecuteSynErr:
    DebugLog "Execute error: " & GetVar("SYN-IMG") & " Error = " & Str(Err.Number) & " (" & Err.Description & ")"
    Exit Sub

End Sub


Public Sub WriteLogFile()
    Static FileID As Integer
    Static LastTimeBeingScanned As String
    Dim NewFile As Boolean
    
    If LogFile = 0 Then Exit Sub
    If Tim = LastTimeBeingScanned Then Exit Sub
    LastTimeBeingScanned = Tim
    
    On Error GoTo LogErr
    If FileID = 0 Then
        NewFile = (Dir(LogFileName) = "")
        FileID = FreeFile()
        Open LogFileName For Append As FileID Len = 1
        If NewFile Then Print #FileID, "Time,Temp,Humidity,WindDirection,WindSpeed,WindGustSpeed,Pressure,Rainfall"
    End If
    Write #FileID, Format$(Now, "dd mmmm yyyy ") & Tim, Tmp, Hum, Direction, Wind, Gust, Prs, Rain
    Exit Sub
    
LogErr:
    MsgBox "Cannot write to Log file " + LogFileName + vbCrLf + Err.Description + Format$(Err.Number, " (#)"), 32, App.FileDescription
    LogFile = False
    Close FileID

End Sub

